from org.python.modules import re;

try :
    nodeName=""
    connected=0
    skipNext=0;

    for o in range (len(sys.argv)):
        if skipNext != 0 :
            skipNext = 0
            continue
        if sys.argv[o] == "--node" :
            nodeName = sys.argv[o+1];
            skipNext = 1
        if sys.argv[o] == "--conntype" :
            if sys.argv[o+1] != "NONE" :
                connected = 1;
            skipNext = 1

    #try to find Resource Adaptor
    resAdaptor = ""
    if nodeName == '' :
        resAdaptor = AdminConfig.getid("/J2CResourceAdapter:ProblemFinderRA");
    else:
        resAdaptor = AdminConfig.getid("/Node:" + nodeName +" /J2CResourceAdapter:ProblemFinderRA");
  
    if resAdaptor == '' :
        print "Warning: Could not find ProblemFinderRA J2CResourceAdapter.";
    else:  
    
      #got Resource Adaptor, retrieving it's propertySet
      propSet = AdminConfig.showAttribute(resAdaptor, "propertySet");
      # and parcing them
      resourceProps = re.findall("(\(.*?\))", AdminConfig.showAttribute(propSet, "resourceProperties"));

      #travercing by properties and searching for empty AMHOME
      for prop in resourceProps:
         name = AdminConfig.showAttribute(prop, "name");
         if name == "AMHOME" :
             value = AdminConfig.showAttribute(prop, "value");
             if value == "" :
                 #once it found - remove it
                 print "Removing empty AMHOME: " + prop;
                 AdminConfig.remove(prop);

      AdminConfig.save()

      from com.ibm.ws.scripting import ScriptingException

      # get cell type (ND or no)
      cell = AdminConfig.getid('/Cell:/')
      cellType = AdminConfig.showAttribute(cell, 'cellType')

      # try to sync node if ND and conntype is not NONE
      if connected and (cellType == 'DISTRIBUTED') :
        try :
            nodeSync = AdminControl.completeObjectName('type=NodeSync,node=' + nodeName + ',*')
            print 'Syncing node ' + nodeName
            AdminControl.invoke(nodeSync, 'sync')
            print 'Syncing for node ' + nodeName + ' successfull'

        except ScriptingException :
            print "An error occured while syncing nodes. Please, ensure that NodeAgent is started."
            print "ITCAM-ERROR"

except Exception :
    print 'An error occured'
    print "ITCAM-ERROR"
    sys.exit(1)
else :
    print "ITCAM-SUCCESS"
    sys.exit(0)
